function getContentBrowser(){
	var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
	                     .getService(Components.interfaces.nsIWindowMediator);
	var topWindowOfType = windowMediator.getMostRecentWindow("navigator:browser");
	if(topWindowOfType) return topWindowOfType.document.getElementById("content");
	return null;
}

function getPrefBranch(){
	if(!tabloc_pref_branch_cache){
		tabloc_pref_branch_cache = Components.classes["@mozilla.org/preferences-service;1"]
		                           .getService(Components.interfaces.nsIPrefBranch);
	}
	return tabloc_pref_branch_cache;
}
var tabloc_pref_branch_cache = null;

function replaceAll(str, oldstr, newstr){
	return str.split(oldstr).join(newstr);
}

function tabloc_href(evt){
	var a = evt.target;
	if(!evt.target){ return; }
	while(a && !a.href){
	  a = a.parentNode;
	}
	if(!a.href){ return; }
	var contentBrowser = getContentBrowser();
	if(!contentBrowser){ return; }

	if(!a.target || (a.target != "_blank")){
	  return;
	}else{
		contentBrowser.addTab(a.href);
	}
	evt.preventDefault();
//	evt.preventBubble();
//	evt.preventCapture();
//	evt.stopPropagation();
}

function tabloc_setBlankTarget(win, tagName, exinpage, exjavascript){
	var doc = win.document;
	var alist = doc.getElementsByTagName(tagName);
	for(var i=0; i<alist.length; i++){
		var a = alist.item(i);
		if(exinpage && a.href){
			var nowhref = win.location.href.split("#")[0];
			if(a.href == nowhref || a.href.indexOf(nowhref + "#") == 0){
				continue;
			}
		}
		if(exjavascript && a.href){
			if(a.href.indexOf("javascript:") == 0){
				continue;
			}
		}
		a.setAttribute("__tabloc_target", a.target);
		a.target = "_blank";
	}
}

function tabloc_restoreTarget(contentDocument, tagName){
	var alist = contentDocument.getElementsByTagName(tagName);
	for(var i=0; i<alist.length; i++){
		var a = alist.item(i);
		if(a.hasAttribute("__tabloc_target")){
			a.target = a.getAttribute("__tabloc_target");
			a.removeAttribute("__tabloc_target");
		}
	}
}

function tabloc_restore(doc, tab, varnode){
	tabloc_restoreTarget(doc, "a");
	tabloc_restoreTarget(doc, "form");
	tabloc_restoreTarget(doc, "link");
	tabloc_restoreTarget(doc, "area");

	var bodylist = doc.getElementsByTagName("body");
	for(var i=0; i<bodylist.length; i++){
		bodylist[i].removeEventListener("click", tabloc_href, true);
	}

	if(varnode.hasAttribute("__tabloc_tabLocked")){
		varnode.removeAttribute("__tabloc_tabLocked");
	}
	if(varnode.hasAttribute("__tabloc_shiftLocked")){
		varnode.removeAttribute("__tabloc_shiftLocked");
	}
	if(varnode.hasAttribute("__tabloc_image")){
		tab.setAttribute("image", varnode.getAttribute("__tabloc_image"));
		varnode.removeAttribute("__tabloc_image");
	}
}

function tabloc_execute_win(win, toTabLock, toShiftLock){
	if(toTabLock) {
		var bodylist = win.document.getElementsByTagName("body");
		for(var i=0; i<bodylist.length; i++){
			bodylist[i].addEventListener("click", tabloc_href, true);
		}
	}

	if(toShiftLock) {
		var exinpage     = tabloc_getPrefValue("skz.tabloc.ex_inpagelink");
		var exform       = tabloc_getPrefValue("skz.tabloc.ex_formsubmit");
		var exjavascript = tabloc_getPrefValue("skz.tabloc.ex_javascript");
		tabloc_setBlankTarget(win, "a",    exinpage, exjavascript);
		tabloc_setBlankTarget(win, "link", exinpage, exjavascript);
		tabloc_setBlankTarget(win, "area", exinpage, exjavascript);
		if(!exform){ tabloc_setBlankTarget(win, "form", exinpage, exjavascript); }
	}
}

function tabloc_execute(toTabLock, toShiftLock){
	var contentBrowser = getContentBrowser();
	var tab = contentBrowser.selectedTab;
	var win = contentBrowser.contentWindow;
	var doc = win.document;
	var html = doc.getElementsByTagName("html")[0];
  var frames = win.frames;

	var tabLocked = false;
	var shiftLocked = false;
	if(html.hasAttribute("__tabloc_tabLocked")){
		tabLocked = (html.getAttribute("__tabloc_tabLocked") == "1");
	}
	if(html.hasAttribute("__tabloc_shiftLocked")){
		shiftLocked = (html.getAttribute("__tabloc_shiftLocked") == "1");
	}
	
  if((toTabLock == tabLocked) && (toShiftLock == shiftLocked)){
  	tabloc_restore(doc, tab, html);
  	return;
  }else if(tabLocked || shiftLocked){
  	tabloc_restore(doc, tab, html);
  }

  for(var i=0; i<frames.length; i++){
		tabloc_execute_win(frames[i], toTabLock, toShiftLock);
  }
	tabloc_execute_win(win, toTabLock, toShiftLock);

	if(toTabLock)   { html.setAttribute("__tabloc_tabLocked", "1");   }
	if(toShiftLock) { html.setAttribute("__tabloc_shiftLocked", "1"); }
	html.setAttribute("__tabloc_image", tab.getAttribute("image"));
	
	if(!toTabLock) {
  	tab.setAttribute("image", tabloc_getSkinUrl() + "s-pin.png");
  }else{
  	tab.setAttribute("image", tabloc_getSkinUrl() + "st-pin.png");
  }
}

function tabloc_tablock(){
	tabloc_execute(true, false);
}

function tabloc_shiftlock(){
	tabloc_execute(false, true);
}

function tabloc_shifttablock(){
	tabloc_execute(true, true);
}

function tabloc_dblclick(){
	switch(tabloc_getPrefValue("skz.tabloc.dblclick_action")){
		case 1: tabloc_tablock(); break;
		case 2: tabloc_shiftlock(); break;
		case 3: tabloc_shifttablock(); break;
		default: break;
	}
}


function tabloc_removeTab(tabElement){
	var contentBrowser = getContentBrowser();
	try{
		var doc = contentBrowser.getBrowserForTab(tabElement).contentDocument;
		var html = doc.getElementsByTagName("html")[0];
		var tabLocked = false;
		var shiftLocked = false;
		if(html.hasAttribute("__tabloc_tabLocked")){
			tabLocked = (html.getAttribute("__tabloc_tabLocked") == "1");
		}
		if(html.hasAttribute("__tabloc_shiftLocked")){
			shiftLocked = (html.getAttribute("__tabloc_shiftLocked") == "1");
		}
		if(contentBrowser.selectedTab == tabElement && 
			tabloc_getPrefValue("skz.tabloc.close_active")){
			contentBrowser.__tabloc_removeTab(tabElement);
			return;
		}
		
		if(tabLocked || shiftLocked){ return; }
	}catch(e){}
	contentBrowser.__tabloc_removeTab(tabElement);
}

function tabloc_addKey(menuid, modifiers, keycode) {
	var key = document.getElementById("key_" + menuid);
  if(keycode.length == 1){
    key.setAttribute("modifiers", modifiers);
    key.setAttribute("key", keycode);
    key.setAttribute("disabled", false);
  }else if(keycode.length > 1){
    key.setAttribute("modifiers", modifiers);
    key.setAttribute("keycode", "VK_" + keycode);
    key.setAttribute("disabled", false);
  }
}

function tabloc_addMenuItem(contentBrowser, menuid) {
	var tabLockMenu = document.getElementById(menuid).cloneNode(false);
	if(!tabLockMenu){ return null; }
	tabLockMenu.id = "tab-" + menuid;
	var menuParent = contentBrowser.mStrip.firstChild.nextSibling;
	var pos = tabloc_getPrefValue("skz.tabloc.menu_pos");
	if(pos >= menuParent.childNodes.length){
	  menuParent.appendChild(tabLockMenu);
	}else{
	  menuParent.insertBefore(tabLockMenu, menuParent.childNodes[pos]);
	}
	return tabLockMenu;
}

function tabloc_addMenuItems() {
	var contentBrowser = getContentBrowser();
	if(!contentBrowser){ return; }

	tabloc_addKey("shiftlockmenu",
		tabloc_getPrefValue("skz.tabloc.keymodifiers_shiftlock"),
		tabloc_getPrefValue("skz.tabloc.key_shiftlock"));
	tabloc_addKey("shifttablockmenu",
		tabloc_getPrefValue("skz.tabloc.keymodifiers_shifttablock"),
		tabloc_getPrefValue("skz.tabloc.key_shifttablock"));

	if(tabloc_getPrefValue("skz.tabloc.add_shiftlock_menu")){
		tabloc_addMenuItem(contentBrowser, "shiftlockmenu")
	}
	if(tabloc_getPrefValue("skz.tabloc.add_shifttablock_menu")){
		tabloc_addMenuItem(contentBrowser, "shifttablockmenu");
	}
	//if(tabloc_getPrefValue("skz.tabloc.add_tablock_menu")){
	//	tabloc_addMenuItem(contentBrowser, "tablockmenu");
	//}
	contentBrowser.tabContainer.addEventListener("dblclick", tabloc_dblclick, false);

	if(tabloc_getPrefValue("skz.tabloc.prevent_close")){
		contentBrowser.__tabloc_removeTab = contentBrowser.removeTab;
		contentBrowser.removeTab = tabloc_removeTab;
	}
}

function tabloc_getSkinUrl(){
	var userskin = tabloc_getPrefValue("skz.tabloc.skin");
	if(userskin != tabloc_getDefaultValue("skz.tabloc.skin")){
		return userskin;
	}
	return "chrome://tabloc/skin/";
}

function tabloc_getPrefValue(aPrefString){
	var defaultValue = tabloc_getDefaultValue(aPrefString);
	var result = defaultValue;

	try{
		switch(typeof(defaultValue)){
			case "boolean":
				result = getPrefBranch().getBoolPref(aPrefString);
				break;
			case "number":
				result = getPrefBranch().getIntPref(aPrefString);
				break;
			case "string":
				result = getPrefBranch().getComplexValue(aPrefString,
					Components.interfaces.nsISupportsString).data;
				break;
		}
	}catch(ex){
		result = defaultValue;
	}		
	return result;
}

function tabloc_getDefaultValue(aPrefString){
	switch(aPrefString){
		case "skz.tabloc.add_tablock_menu":
			return false;
		case "skz.tabloc.add_shiftlock_menu":
			return true;
		case "skz.tabloc.keymodifiers_shiftlock":
			return "accel,shift";
		case "skz.tabloc.key_shiftlock":
			return "";
		case "skz.tabloc.add_shifttablock_menu":
			return true;
		case "skz.tabloc.keymodifiers_shifttablock":
			return "accel,shift";
		case "skz.tabloc.key_shifttablock":
			return "";
		case "skz.tabloc.menu_pos":
			return 2;
		case "skz.tabloc.dblclick_action":
			return 3;
		case "skz.tabloc.prevent_close":
			return false;
		case "skz.tabloc.close_active":
			return false;
		case "skz.tabloc.ex_inpagelink":
			return false;
		case "skz.tabloc.ex_javascript":
			return true;
		case "skz.tabloc.ex_formsubmit":
			return false;
		case "skz.tabloc.skin":
			return "(default)";
		case "skz.tabloc.skindirs":
			return "(default);";
	}
	return 0;
}

